25243fd911a2532e8eeea8f5a3f8a7835d1452ca
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2023 Cisco and/or its affiliates.
2 # Copyright (c) 2023 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
46     case_text="${NODENESS}_${FLAVOR}"
47     case "${case_text}" in
48         "1n_skx" | "1n_tx2")
49             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
50             # script's functions. Env variables are read from ssh output
51             # back to localhost for further processing.
52             # Shim and Jenkins executor are in the same network on the same host
53             # Connect to docker's default gateway IP and shim's exposed port
54             ssh="ssh root@172.17.0.1 -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # The "declare -f" output is long and boring.
57             set +x
58             # backtics to avoid https://midnight-commander.org/ticket/2142
59             env_vars=`${ssh} "$(declare -f); ${run}"` || {
60                 die "Topology reservation via shim-dcr failed!"
61             }
62             set -x
63             set -a
64             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
65                 die "Source failed!"
66             }
67             set +a
68             ;;
69         "1n_vbox")
70             # We execute reservation on localhost. Sourced script automatially
71             # sets environment variables for further processing.
72             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
73             ;;
74         *)
75             die "Unknown specification: ${case_text}!"
76     esac
77
78     trap 'deactivate_docker_topology' EXIT || {
79          die "Trap attempt failed, please cleanup manually. Aborting!"
80     }
81
82     parse_env_variables || die "Parse of environment variables failed!"
83
84     # Replace all variables in template with those in environment.
85     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
86         die "Topology file create failed!"
87     }
88
89     WORKING_TOPOLOGY="${CSIT_DIR}/topologies/available/vpp_device.yaml"
90     mv topo.yml "${WORKING_TOPOLOGY}" || {
91         die "Topology move failed!"
92     }
93     cat ${WORKING_TOPOLOGY} | grep -v password || {
94         die "Topology read failed!"
95     }
96 }
97
98
99 function activate_virtualenv () {
100
101     # Update virtualenv pip package, delete and create virtualenv directory,
102     # activate the virtualenv, install requirements, set PYTHONPATH.
103
104     # Arguments:
105     # - ${1} - Path to existing directory for creating virtualenv in.
106     #          If missing or empty, ${CSIT_DIR} is used.
107     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
108     # Variables read:
109     # - CSIT_DIR - Path to existing root of local CSIT git repository.
110     # Variables exported:
111     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
112     # Functions called:
113     # - die - Print to stderr and exit.
114
115     set -exuo pipefail
116
117     root_path="${1-$CSIT_DIR}"
118     env_dir="${root_path}/env"
119     req_path=${2-$CSIT_DIR/requirements.txt}
120     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
121     pip3 install virtualenv==20.15.1 || {
122         die "Virtualenv package install failed."
123     }
124     virtualenv --no-download --python=$(which python3) "${env_dir}" || {
125         die "Virtualenv creation for $(which python3) failed."
126     }
127     set +u
128     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
129     set -u
130     pip3 install -r "${req_path}" || {
131         die "Requirements installation failed."
132     }
133     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
134     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
135 }
136
137
138 function archive_tests () {
139
140     # Create .tar.gz of generated/tests for archiving.
141     # To be run after generate_tests, kept separate to offer more flexibility.
142
143     # Directory read:
144     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
145     # File rewriten:
146     # - ${ARCHIVE_DIR}/generated_tests.tar.gz - Archive of generated tests.
147
148     set -exuo pipefail
149
150     pushd "${ARCHIVE_DIR}" || die
151     tar czf "generated_tests.tar.gz" "${GENERATED_DIR}/tests" || true
152     popd || die
153 }
154
155
156 function check_download_dir () {
157
158     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
159     #
160     # Variables read:
161     # - DOWNLOAD_DIR - Path to directory pybot takes the build to test from.
162     # Directories read:
163     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
164     # Functions called:
165     # - die - Print to stderr and exit.
166
167     set -exuo pipefail
168
169     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
170         die "No artifacts downloaded!"
171     fi
172 }
173
174
175 function check_prerequisites () {
176
177     # Fail if prerequisites are not met.
178     #
179     # Functions called:
180     # - installed - Check if application is installed/present in system.
181     # - die - Print to stderr and exit.
182
183     set -exuo pipefail
184
185     if ! installed sshpass; then
186         die "Please install sshpass before continue!"
187     fi
188 }
189
190
191 function common_dirs () {
192
193     # Set global variables, create some directories (without touching content).
194
195     # Variables set:
196     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
197     # - CSIT_DIR - Path to existing root of local CSIT git repository.
198     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
199     # - JOB_SPECS_DIR - Path to existing directory with job test specifications.
200     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
201     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
202     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
203     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archives".
204     #   The name is chosen to match what ci-management expects.
205     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
206     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
207     # Directories created if not present:
208     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
209     # Functions called:
210     # - die - Print to stderr and exit.
211
212     set -exuo pipefail
213
214     this_file=$(readlink -e "${BASH_SOURCE[0]}") || {
215         die "Some error during locating of this source file."
216     }
217     BASH_FUNCTION_DIR=$(dirname "${this_file}") || {
218         die "Some error during dirname call."
219     }
220     # Current working directory could be in a different repo, e.g. VPP.
221     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
222     relative_csit_dir=$(git rev-parse --show-toplevel) || {
223         die "Git rev-parse failed."
224     }
225     CSIT_DIR=$(readlink -e "${relative_csit_dir}") || die "Readlink failed."
226     popd || die "Popd failed."
227     TOPOLOGIES_DIR=$(readlink -e "${CSIT_DIR}/topologies/available") || {
228         die "Readlink failed."
229     }
230     JOB_SPECS_DIR=$(readlink -e "${CSIT_DIR}/resources/job_specs") || {
231         die "Readlink failed."
232     }
233     RESOURCES_DIR=$(readlink -e "${CSIT_DIR}/resources") || {
234         die "Readlink failed."
235     }
236     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
237         die "Readlink failed."
238     }
239     DOC_GEN_DIR=$(readlink -e "${TOOLS_DIR}/doc_gen") || {
240         die "Readlink failed."
241     }
242     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
243         die "Readlink failed."
244     }
245
246     ARCHIVE_DIR=$(readlink -f "${CSIT_DIR}/archives") || {
247         die "Readlink failed."
248     }
249     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
250     DOWNLOAD_DIR=$(readlink -f "${CSIT_DIR}/download_dir") || {
251         die "Readlink failed."
252     }
253     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
254     GENERATED_DIR=$(readlink -f "${CSIT_DIR}/generated") || {
255         die "Readlink failed."
256     }
257     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
258 }
259
260
261 function compose_pybot_arguments () {
262
263     # Variables read:
264     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
265     # - DUT - CSIT test/ subdirectory, set while processing tags.
266     # - TAGS - Array variable holding selected tag boolean expressions.
267     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
268     # - TEST_CODE - The test selection string from environment or argument.
269     # - SELECTION_MODE - Selection criteria [test, suite, include, exclude].
270     # Variables set:
271     # - PYBOT_ARGS - String holding part of all arguments for pybot.
272     # - EXPANDED_TAGS - Array of strings pybot arguments compiled from tags.
273
274     set -exuo pipefail
275
276     # No explicit check needed with "set -u".
277     PYBOT_ARGS=("--loglevel" "TRACE")
278     PYBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
279
280     case "${TEST_CODE}" in
281         *"device"*)
282             PYBOT_ARGS+=("--suite" "tests.${DUT}.device")
283             ;;
284         *"perf"*)
285             PYBOT_ARGS+=("--suite" "tests.${DUT}.perf")
286             ;;
287         *)
288             die "Unknown specification: ${TEST_CODE}"
289     esac
290
291     EXPANDED_TAGS=()
292     for tag in "${TAGS[@]}"; do
293         if [[ ${tag} == "!"* ]]; then
294             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
295         else
296             if [[ ${SELECTION_MODE} == "--test" ]]; then
297                 EXPANDED_TAGS+=("--test" "${tag}")
298             else
299                 EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
300             fi
301         fi
302     done
303
304     if [[ ${SELECTION_MODE} == "--test" ]]; then
305         EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}")
306     fi
307 }
308
309
310 function deactivate_docker_topology () {
311
312     # Deactivate virtual vpp-device topology by removing containers.
313     #
314     # Variables read:
315     # - NODENESS - Node multiplicity of desired testbed.
316     # - FLAVOR - Node flavor string, usually describing the processor.
317
318     set -exuo pipefail
319
320     case_text="${NODENESS}_${FLAVOR}"
321     case "${case_text}" in
322         "1n_skx" | "1n_tx2")
323             ssh="ssh root@172.17.0.1 -p 6022"
324             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
325             # The "declare -f" output is long and boring.
326             set +x
327             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
328                 die "Topology cleanup via shim-dcr failed!"
329             }
330             set -x
331             ;;
332         "1n_vbox")
333             enter_mutex || die
334             clean_environment || {
335                 die "Topology cleanup locally failed!"
336             }
337             exit_mutex || die
338             ;;
339         *)
340             die "Unknown specification: ${case_text}!"
341     esac
342 }
343
344
345 function die () {
346
347     # Print the message to standard error end exit with error code specified
348     # by the second argument.
349     #
350     # Hardcoded values:
351     # - The default error message.
352     # Arguments:
353     # - ${1} - The whole error message, be sure to quote. Optional
354     # - ${2} - the code to exit with, default: 1.
355
356     set -x
357     set +eu
358     warn "${1:-Unspecified run-time error occurred!}"
359     exit "${2:-1}"
360 }
361
362
363 function die_on_pybot_error () {
364
365     # Source this fragment if you want to abort on any failed test case.
366     #
367     # Variables read:
368     # - PYBOT_EXIT_STATUS - Set by a pybot running fragment.
369     # Functions called:
370     # - die - Print to stderr and exit.
371
372     set -exuo pipefail
373
374     if [[ "${PYBOT_EXIT_STATUS}" != "0" ]]; then
375         die "Test failures are present!" "${PYBOT_EXIT_STATUS}"
376     fi
377 }
378
379
380 function generate_tests () {
381
382     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
383     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
384     # The generation is done by executing any *.py executable
385     # within any subdirectory after copying.
386
387     # This is a separate function, because this code is called
388     # both by autogen checker and entries calling run_pybot.
389
390     # Directories read:
391     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
392     # Directories replaced:
393     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
394
395     set -exuo pipefail
396
397     rm -rf "${GENERATED_DIR}/tests" || die
398     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
399     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
400     cmd_line+=("-executable" "-name" "*.py")
401     # We sort the directories, so log output can be compared between runs.
402     file_list=$("${cmd_line[@]}" | sort) || die
403
404     for gen in ${file_list}; do
405         directory="$(dirname "${gen}")" || die
406         filename="$(basename "${gen}")" || die
407         pushd "${directory}" || die
408         ./"${filename}" || die
409         popd || die
410     done
411 }
412
413
414 function get_test_code () {
415
416     # Arguments:
417     # - ${1} - Optional, argument of entry script (or empty as unset).
418     #   Test code value to override job name from environment.
419     # Variables read:
420     # - JOB_NAME - String affecting test selection, default if not argument.
421     # Variables set:
422     # - TEST_CODE - The test selection string from environment or argument.
423     # - NODENESS - Node multiplicity of desired testbed.
424     # - FLAVOR - Node flavor string, usually describing the processor.
425
426     set -exuo pipefail
427
428     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
429     if [[ -z "${TEST_CODE}" ]]; then
430         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
431     fi
432
433     case "${TEST_CODE}" in
434         *"1n-vbox"*)
435             NODENESS="1n"
436             FLAVOR="vbox"
437             ;;
438         *"1n-skx"*)
439             NODENESS="1n"
440             FLAVOR="skx"
441             ;;
442         *"1n-tx2"*)
443             NODENESS="1n"
444             FLAVOR="tx2"
445             ;;
446         *"1n-aws"*)
447             NODENESS="1n"
448             FLAVOR="aws"
449             ;;
450         *"2n-aws"*)
451             NODENESS="2n"
452             FLAVOR="aws"
453             ;;
454         *"3n-aws"*)
455             NODENESS="3n"
456             FLAVOR="aws"
457             ;;
458         *"2n-zn2"*)
459             NODENESS="2n"
460             FLAVOR="zn2"
461             ;;
462         *"2n-clx"*)
463             NODENESS="2n"
464             FLAVOR="clx"
465             ;;
466         *"2n-icx"*)
467             NODENESS="2n"
468             FLAVOR="icx"
469             ;;
470         *"2n-spr"*)
471             NODENESS="2n"
472             FLAVOR="spr"
473             ;;
474         *"3n-icx"*)
475             NODENESS="3n"
476             FLAVOR="icx"
477             ;;
478         *"3na-spr"*)
479             NODENESS="3na"
480             FLAVOR="spr"
481             ;;
482         *"3nb-spr"*)
483             NODENESS="3nb"
484             FLAVOR="spr"
485             ;;
486         *"3n-snr"*)
487             NODENESS="3n"
488             FLAVOR="snr"
489             ;;
490         *"2n-tx2"*)
491             NODENESS="2n"
492             FLAVOR="tx2"
493             ;;
494         *"3n-tsh"*)
495             NODENESS="3n"
496             FLAVOR="tsh"
497             ;;
498         *"3n-alt"*)
499             NODENESS="3n"
500             FLAVOR="alt"
501             ;;
502     esac
503 }
504
505
506 function get_test_tag_string () {
507
508     # Variables read:
509     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
510     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
511     # - TEST_CODE - The test selection string from environment or argument.
512     # Variables set:
513     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
514     #   May be empty, or even not set on event types not adding comment.
515
516     # TODO: ci-management scripts no longer need to perform this.
517
518     set -exuo pipefail
519
520     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
521         case "${TEST_CODE}" in
522             *"device"*)
523                 trigger="devicetest"
524                 ;;
525             *"perf"*)
526                 trigger="perftest"
527                 ;;
528             *)
529                 die "Unknown specification: ${TEST_CODE}"
530         esac
531         # Ignore lines not containing the trigger word.
532         comment=$(fgrep "${trigger}" <<< "${GERRIT_EVENT_COMMENT_TEXT}" || true)
533         # The vpp-csit triggers trail stuff we are not interested in.
534         # Removing them and trigger word: https://unix.stackexchange.com/a/13472
535         # (except relying on \s whitespace, \S non-whitespace and . both).
536         # The last string is concatenated, only the middle part is expanded.
537         cmd=("grep" "-oP" '\S*'"${trigger}"'\S*\s\K.+$') || die "Unset trigger?"
538         # On parsing error, TEST_TAG_STRING probably stays empty.
539         TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
540         if [[ -z "${TEST_TAG_STRING-}" ]]; then
541             # Probably we got a base64 encoded comment.
542             comment="${GERRIT_EVENT_COMMENT_TEXT}"
543             comment=$(base64 --decode <<< "${comment}" || true)
544             comment=$(fgrep "${trigger}" <<< "${comment}" || true)
545             TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
546         fi
547         if [[ -n "${TEST_TAG_STRING-}" ]]; then
548             test_tag_array=(${TEST_TAG_STRING})
549             if [[ "${test_tag_array[0]}" == "icl" ]]; then
550                 export GRAPH_NODE_VARIANT="icl"
551                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
552             elif [[ "${test_tag_array[0]}" == "skx" ]]; then
553                 export GRAPH_NODE_VARIANT="skx"
554                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
555             fi
556         fi
557     fi
558 }
559
560
561 function installed () {
562
563     # Check if the given utility is installed. Fail if not installed.
564     #
565     # Duplicate of common.sh function, as this file is also used standalone.
566     #
567     # Arguments:
568     # - ${1} - Utility to check.
569     # Returns:
570     # - 0 - If command is installed.
571     # - 1 - If command is not installed.
572
573     set -exuo pipefail
574
575     command -v "${1}"
576 }
577
578
579 function move_archives () {
580
581     # Move archive directory to top of workspace, if not already there.
582     #
583     # ARCHIVE_DIR is positioned relative to CSIT_DIR,
584     # but in some jobs CSIT_DIR is not same as WORKSPACE
585     # (e.g. under VPP_DIR). To simplify ci-management settings,
586     # we want to move the data to the top. We do not want simple copy,
587     # as ci-management is eager with recursive search.
588     #
589     # As some scripts may call this function multiple times,
590     # the actual implementation use copying and deletion,
591     # so the workspace gets "union" of contents (except overwrites on conflict).
592     # The consequence is empty ARCHIVE_DIR remaining after this call.
593     #
594     # As the source directory is emptied,
595     # the check for dirs being different is essential.
596     #
597     # Variables read:
598     # - WORKSPACE - Jenkins workspace, move only if the value is not empty.
599     #   Can be unset, then it speeds up manual testing.
600     # - ARCHIVE_DIR - Path to directory with content to be moved.
601     # Directories updated:
602     # - ${WORKSPACE}/archives/ - Created if does not exist.
603     #   Content of ${ARCHIVE_DIR}/ is moved.
604     # Functions called:
605     # - die - Print to stderr and exit.
606
607     set -exuo pipefail
608
609     if [[ -n "${WORKSPACE-}" ]]; then
610         target=$(readlink -f "${WORKSPACE}/archives")
611         if [[ "${target}" != "${ARCHIVE_DIR}" ]]; then
612             mkdir -p "${target}" || die "Archives dir create failed."
613             cp -rf "${ARCHIVE_DIR}"/* "${target}" || die "Copy failed."
614             rm -rf "${ARCHIVE_DIR}"/* || die "Delete failed."
615         fi
616     fi
617 }
618
619
620 function post_process_robot_outputs () {
621
622     # Generate INFO level output_info.xml by rebot.
623     #
624     # Variables read:
625     # - ARCHIVE_DIR - Path to post-processed files.
626
627     set -exuo pipefail
628
629     # Generate INFO level output_info.xml for post-processing.
630     all_options=("--loglevel" "INFO")
631     all_options+=("--log" "none")
632     all_options+=("--report" "none")
633     all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
634     all_options+=("${ARCHIVE_DIR}/output.xml")
635     rebot "${all_options[@]}" || true
636 }
637
638
639 function prepare_topology () {
640
641     # Prepare virtual testbed topology if needed based on flavor.
642
643     # Variables read:
644     # - TEST_CODE - String affecting test selection, usually jenkins job name.
645     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
646     # - FLAVOR - Node flavor string, e.g. "clx" or "skx".
647     # Variables set:
648     # - TERRAFORM_MODULE_DIR - Terraform module directory.
649     # Functions called:
650     # - die - Print to stderr and exit.
651     # - terraform_init - Terraform init topology.
652     # - terraform_apply - Terraform apply topology.
653
654     set -exuo pipefail
655
656     case_text="${NODENESS}_${FLAVOR}"
657     case "${case_text}" in
658         "1n_aws" | "2n_aws" | "3n_aws")
659             export TF_VAR_testbed_name="${TEST_CODE}"
660             TERRAFORM_MODULE_DIR="terraform-aws-${NODENESS}-${FLAVOR}-c5n"
661             terraform_init || die "Failed to call terraform init."
662             trap 'terraform_destroy' ERR || {
663                 die "Trap attempt failed, please cleanup manually. Aborting!"
664             }
665             terraform_apply || die "Failed to call terraform apply."
666             ;;
667     esac
668 }
669
670
671 function reserve_and_cleanup_testbed () {
672
673     # Reserve physical testbed, perform cleanup, register trap to unreserve.
674     # When cleanup fails, remove from topologies and keep retrying
675     # until all topologies are removed.
676     #
677     # Variables read:
678     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
679     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
680     # - BUILD_TAG - Any string suitable as filename, identifying
681     #   test run executing this function. May be unset.
682     # Variables set:
683     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
684     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
685     # Functions called:
686     # - die - Print to stderr and exit.
687     # - ansible_playbook - Perform an action using ansible, see ansible.sh
688     # Traps registered:
689     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
690
691     set -exuo pipefail
692
693     while true; do
694         for topo in "${TOPOLOGIES[@]}"; do
695             set +e
696             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
697             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
698             python3 "${scrpt}" "${opts[@]}"
699             result="$?"
700             set -e
701             if [[ "${result}" == "0" ]]; then
702                 # Trap unreservation before cleanup check,
703                 # so multiple jobs showing failed cleanup improve chances
704                 # of humans to notice and fix.
705                 WORKING_TOPOLOGY="${topo}"
706                 echo "Reserved: ${WORKING_TOPOLOGY}"
707                 trap "untrap_and_unreserve_testbed" EXIT || {
708                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
709                     untrap_and_unreserve_testbed "${message}" || {
710                         die "Teardown should have died, not failed."
711                     }
712                     die "Trap attempt failed, unreserve succeeded. Aborting."
713                 }
714                 # Cleanup + calibration checks
715                 set +e
716                 ansible_playbook "cleanup, calibration"
717                 result="$?"
718                 set -e
719                 if [[ "${result}" == "0" ]]; then
720                     break
721                 fi
722                 warn "Testbed cleanup failed: ${topo}"
723                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
724             fi
725             # Else testbed is accessible but currently reserved, moving on.
726         done
727
728         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
729             # Exit the infinite while loop if we made a reservation.
730             warn "Reservation and cleanup successful."
731             break
732         fi
733
734         if [[ "${#TOPOLOGIES[@]}" == "0" ]]; then
735             die "Run out of operational testbeds!"
736         fi
737
738         # Wait ~3minutes before next try.
739         sleep_time="$[ ( ${RANDOM} % 20 ) + 180 ]s" || {
740             die "Sleep time calculation failed."
741         }
742         echo "Sleeping ${sleep_time}"
743         sleep "${sleep_time}" || die "Sleep failed."
744     done
745 }
746
747
748 function run_pybot () {
749
750     # Run pybot with options based on input variables.
751     # Generate INFO level output_info.xml by rebot.
752     #
753     # Variables read:
754     # - CSIT_DIR - Path to existing root of local CSIT git repository.
755     # - ARCHIVE_DIR - Path to store robot result files in.
756     # - PYBOT_ARGS, EXPANDED_TAGS - See compose_pybot_arguments.sh
757     # - GENERATED_DIR - Tests are assumed to be generated under there.
758     # Variables set:
759     # - PYBOT_EXIT_STATUS - Exit status of most recent pybot invocation.
760     # Functions called:
761     # - die - Print to stderr and exit.
762
763     set -exuo pipefail
764
765     all_options=("--outputdir" "${ARCHIVE_DIR}" "${PYBOT_ARGS[@]}")
766     all_options+=("${EXPANDED_TAGS[@]}")
767
768     pushd "${CSIT_DIR}" || die "Change directory operation failed."
769     set +e
770     robot "${all_options[@]}" "${GENERATED_DIR}/tests/"
771     PYBOT_EXIT_STATUS="$?"
772     set -e
773
774     post_process_robot_outputs || die
775
776     popd || die "Change directory operation failed."
777 }
778
779
780 function select_arch_os () {
781
782     # Set variables affected by local CPU architecture and operating system.
783     #
784     # Variables set:
785     # - VPP_VER_FILE - Name of file in CSIT dir containing vpp stable version.
786     # - IMAGE_VER_FILE - Name of file in CSIT dir containing the image name.
787     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
788
789     set -exuo pipefail
790
791     source /etc/os-release || die "Get OS release failed."
792
793     case "${ID}" in
794         "ubuntu"*)
795             case "${VERSION}" in
796                 *"LTS (Jammy Jellyfish)"*)
797                     IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU_JAMMY"
798                     VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_JAMMY"
799                     PKG_SUFFIX="deb"
800                     ;;
801                 *)
802                     die "Unsupported Ubuntu version!"
803                     ;;
804             esac
805             ;;
806         *)
807             die "Unsupported distro or OS!"
808             ;;
809     esac
810
811     arch=$(uname -m) || {
812         die "Get CPU architecture failed."
813     }
814
815     case "${arch}" in
816         "aarch64")
817             IMAGE_VER_FILE="${IMAGE_VER_FILE}_ARM"
818             ;;
819         *)
820             ;;
821     esac
822 }
823
824
825 function select_tags () {
826
827     # Variables read:
828     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
829     # - TEST_CODE - String affecting test selection, usually jenkins job name.
830     # - DUT - CSIT test/ subdirectory, set while processing tags.
831     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
832     #   Can be unset.
833     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
834     # - BASH_FUNCTION_DIR - Directory with input files to process.
835     # Variables set:
836     # - TAGS - Array of processed tag boolean expressions.
837     # - SELECTION_MODE - Selection criteria [test, suite, include, exclude].
838
839     set -exuo pipefail
840
841     # NIC SELECTION
842     case "${TEST_CODE}" in
843         *"1n-aws"*)
844             start_pattern='^  SUT:'
845             ;;
846         *)
847             start_pattern='^  TG:'
848             ;;
849     esac
850     end_pattern='^ \? \?[A-Za-z0-9]\+:'
851     # Remove the sections from topology file
852     sed_command="/${start_pattern}/,/${end_pattern}/d"
853     # All topologies NICs
854     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
855                 | grep -hoP "model: \K.*" | sort -u)
856     # Selected topology NICs
857     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
858                | grep -hoP "model: \K.*" | sort -u)
859     # All topologies NICs - Selected topology NICs
860     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
861         die "Computation of excluded NICs failed."
862     }
863
864     # Select default NIC tag.
865     case "${TEST_CODE}" in
866         *"3n-snr"*)
867             default_nic="nic_intel-e822cq"
868             ;;
869         *"3n-tsh"*)
870             default_nic="nic_intel-x520-da2"
871             ;;
872         *"3n-icx"* | *"2n-icx"*)
873             default_nic="nic_intel-xxv710"
874             ;;
875         *"3na-spr"*)
876             default_nic="nic_mellanox-cx7veat"
877             ;;
878         *"3nb-spr"*)
879             default_nic="nic_intel-e810cq"
880             ;;
881         *"2n-spr"*)
882             default_nic="nic_intel-e810cq"
883             ;;
884         *"2n-clx"* | *"2n-zn2"*)
885             default_nic="nic_intel-xxv710"
886             ;;
887         *"2n-tx2"* | *"3n-alt"*)
888             default_nic="nic_intel-xl710"
889             ;;
890         *"1n-aws"* | *"2n-aws"* | *"3n-aws"*)
891             default_nic="nic_amazon-nitro-50g"
892             ;;
893         *)
894             default_nic="nic_intel-x710"
895             ;;
896     esac
897
898     sed_nic_sub_cmd="sed s/\${default_nic}/${default_nic}/"
899     awk_nics_sub_cmd=""
900     awk_nics_sub_cmd+='gsub("xxv710","25ge2p1xxv710");'
901     awk_nics_sub_cmd+='gsub("x710","10ge2p1x710");'
902     awk_nics_sub_cmd+='gsub("xl710","40ge2p1xl710");'
903     awk_nics_sub_cmd+='gsub("x520-da2","10ge2p1x520");'
904     awk_nics_sub_cmd+='gsub("cx556a","100ge2p1cx556a");'
905     awk_nics_sub_cmd+='gsub("cx7veat","200ge2p1cx7veat");'
906     awk_nics_sub_cmd+='gsub("e810cq","100ge2p1e810cq");'
907     awk_nics_sub_cmd+='gsub("vic1227","10ge2p1vic1227");'
908     awk_nics_sub_cmd+='gsub("vic1385","40ge2p1vic1385");'
909     awk_nics_sub_cmd+='gsub("nitro-50g","50ge1p1ENA");'
910     awk_nics_sub_cmd+='if ($9 =="drv_avf") drv="avf-";'
911     awk_nics_sub_cmd+='else if ($9 =="drv_rdma_core") drv ="rdma-";'
912     awk_nics_sub_cmd+='else if ($9 =="drv_mlx5_core") drv ="mlx5-";'
913     awk_nics_sub_cmd+='else if ($9 =="drv_af_xdp") drv ="af-xdp-";'
914     awk_nics_sub_cmd+='else drv="";'
915     awk_nics_sub_cmd+='if ($1 =="-") cores="";'
916     awk_nics_sub_cmd+='else cores=$1;'
917     awk_nics_sub_cmd+='print "*"$7"-" drv $11"-"$5"."$3"-" cores "-" drv $11"-"$5'
918
919     # Tag file directory shorthand.
920     tfd="${JOB_SPECS_DIR}"
921     case "${TEST_CODE}" in
922         # Select specific performance tests based on jenkins job type variable.
923         *"device"* )
924             readarray -t test_tag_array <<< $(grep -v "#" \
925                 ${tfd}/vpp_device/${DUT}-${NODENESS}-${FLAVOR}.md |
926                 awk {"$awk_nics_sub_cmd"} || echo "devicetest") || die
927             SELECTION_MODE="--test"
928             ;;
929         *"hoststack-daily"* )
930             readarray -t test_tag_array <<< $(grep -v "#" \
931                 ${tfd}/hoststack_daily/${DUT}-${NODENESS}-${FLAVOR}.md |
932                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
933             SELECTION_MODE="--test"
934             ;;
935         *"ndrpdr-weekly"* )
936             readarray -t test_tag_array <<< $(grep -v "#" \
937                 ${tfd}/ndrpdr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
938                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
939             SELECTION_MODE="--test"
940             ;;
941         *"mrr-daily"* )
942             readarray -t test_tag_array <<< $(grep -v "#" \
943                 ${tfd}/mrr_daily/${DUT}-${NODENESS}-${FLAVOR}.md |
944                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
945             SELECTION_MODE="--test"
946             ;;
947         *"mrr-weekly"* )
948             readarray -t test_tag_array <<< $(grep -v "#" \
949                 ${tfd}/mrr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
950                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
951             SELECTION_MODE="--test"
952             ;;
953         *"report-iterative"* )
954             test_sets=(${TEST_TAG_STRING//:/ })
955             # Run only one test set per run
956             report_file=${test_sets[0]}.md
957             readarray -t test_tag_array <<< $(grep -v "#" \
958                 ${tfd}/report_iterative/${NODENESS}-${FLAVOR}/${report_file} |
959                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
960             SELECTION_MODE="--test"
961             ;;
962         *"report-coverage"* )
963             test_sets=(${TEST_TAG_STRING//:/ })
964             # Run only one test set per run
965             report_file=${test_sets[0]}.md
966             readarray -t test_tag_array <<< $(grep -v "#" \
967                 ${tfd}/report_coverage/${NODENESS}-${FLAVOR}/${report_file} |
968                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
969             SELECTION_MODE="--test"
970             ;;
971         * )
972             if [[ -z "${TEST_TAG_STRING-}" ]]; then
973                 # If nothing is specified, we will run pre-selected tests by
974                 # following tags.
975                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDethip4-ip4base"
976                                 "mrrAND${default_nic}AND1cAND78bANDethip6-ip6base"
977                                 "mrrAND${default_nic}AND1cAND64bANDeth-l2bdbasemaclrn"
978                                 "mrrAND${default_nic}AND1cAND64bANDeth-l2xcbase"
979                                 "!drv_af_xdp" "!drv_avf")
980             else
981                 # If trigger contains tags, split them into array.
982                 test_tag_array=(${TEST_TAG_STRING//:/ })
983             fi
984             SELECTION_MODE="--include"
985             ;;
986     esac
987
988     # Blacklisting certain tags per topology.
989     #
990     # Reasons for blacklisting:
991     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
992     case "${TEST_CODE}" in
993         *"1n-vbox"*)
994             test_tag_array+=("!avf")
995             test_tag_array+=("!vhost")
996             test_tag_array+=("!flow")
997             ;;
998         *"1n_tx2"*)
999             test_tag_array+=("!flow")
1000             ;;
1001         *"2n-clx"*)
1002             test_tag_array+=("!ipsechw")
1003             ;;
1004         *"2n-icx"*)
1005             test_tag_array+=("!ipsechw")
1006             ;;
1007         *"2n-spr"*)
1008             test_tag_array+=("!ipsechw")
1009             ;;
1010         *"2n-tx2"*)
1011             test_tag_array+=("!ipsechw")
1012             ;;
1013         *"2n-zn2"*)
1014             test_tag_array+=("!ipsechw")
1015             ;;
1016         *"3n-alt"*)
1017             test_tag_array+=("!ipsechw")
1018             ;;
1019         *"3n-icx"*)
1020             test_tag_array+=("!ipsechw")
1021             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
1022             ;;
1023         *"3n-snr"*)
1024             ;;
1025         *"3na-spr"*)
1026             test_tag_array+=("!ipsechw")
1027             ;;
1028         *"3nb-spr"*)
1029             test_tag_array+=("!ipsechw")
1030             ;;
1031         *"3n-tsh"*)
1032             test_tag_array+=("!drv_avf")
1033             test_tag_array+=("!ipsechw")
1034             ;;
1035         *"1n-aws"* | *"2n-aws"* | *"3n-aws"*)
1036             test_tag_array+=("!ipsechw")
1037             ;;
1038     esac
1039
1040     # We will add excluded NICs.
1041     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
1042
1043     TAGS=()
1044     prefix=""
1045
1046     set +x
1047     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
1048         if [[ "${TEST_CODE}" != *"device"* ]]; then
1049             # Automatic prefixing for VPP perf jobs to limit the NIC used and
1050             # traffic evaluation to MRR.
1051             if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
1052                 prefix="${prefix}mrrAND"
1053             else
1054                 prefix="${prefix}mrrAND${default_nic}AND"
1055             fi
1056         fi
1057     fi
1058     for tag in "${test_tag_array[@]}"; do
1059         if [[ "${tag}" == "!"* ]]; then
1060             # Exclude tags are not prefixed.
1061             TAGS+=("${tag}")
1062         elif [[ "${tag}" == " "* || "${tag}" == *"perftest"* ]]; then
1063             # Badly formed tag expressions can trigger way too much tests.
1064             set -x
1065             warn "The following tag expression hints at bad trigger: ${tag}"
1066             warn "Possible cause: Multiple triggers in a single comment."
1067             die "Aborting to avoid triggering too many tests."
1068         elif [[ "${tag}" == *"OR"* ]]; then
1069             # If OR had higher precedence than AND, it would be useful here.
1070             # Some people think it does, thus triggering way too much tests.
1071             set -x
1072             warn "The following tag expression hints at bad trigger: ${tag}"
1073             warn "Operator OR has lower precedence than AND. Use space instead."
1074             die "Aborting to avoid triggering too many tests."
1075         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
1076             # Empty and comment lines are skipped.
1077             # Other lines are normal tags, they are to be prefixed.
1078             TAGS+=("${prefix}${tag}")
1079         fi
1080     done
1081     set -x
1082 }
1083
1084
1085 function select_topology () {
1086
1087     # Variables read:
1088     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
1089     # - FLAVOR - Node flavor string, e.g. "clx" or "skx".
1090     # - CSIT_DIR - Path to existing root of local CSIT git repository.
1091     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
1092     # Variables set:
1093     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
1094     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
1095     # Functions called:
1096     # - die - Print to stderr and exit.
1097
1098     set -exuo pipefail
1099
1100     case_text="${NODENESS}_${FLAVOR}"
1101     case "${case_text}" in
1102         "1n_vbox")
1103             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
1104             TOPOLOGIES_TAGS="2_node_single_link_topo"
1105             ;;
1106         "1n_skx" | "1n_tx2")
1107             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
1108             TOPOLOGIES_TAGS="2_node_single_link_topo"
1109             ;;
1110         "2n_skx")
1111             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
1112             TOPOLOGIES_TAGS="2_node_*_link_topo"
1113             ;;
1114         "2n_zn2")
1115             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_zn2*.yaml )
1116             TOPOLOGIES_TAGS="2_node_*_link_topo"
1117             ;;
1118         "3n_skx")
1119             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
1120             TOPOLOGIES_TAGS="3_node_*_link_topo"
1121             ;;
1122         "3n_icx")
1123             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_icx*.yaml )
1124             TOPOLOGIES_TAGS="3_node_*_link_topo"
1125             ;;
1126         "3na_spr")
1127             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3na_spr*.yaml )
1128             TOPOLOGIES_TAGS="3_node_*_link_topo"
1129             ;;
1130         "3nb_spr")
1131             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3nb_spr*.yaml )
1132             TOPOLOGIES_TAGS="3_node_*_link_topo"
1133             ;;
1134         "2n_clx")
1135             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_clx*.yaml )
1136             TOPOLOGIES_TAGS="2_node_*_link_topo"
1137             ;;
1138         "2n_icx")
1139             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_icx*.yaml )
1140             TOPOLOGIES_TAGS="2_node_*_link_topo"
1141             ;;
1142         "2n_spr")
1143             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_spr*.yaml )
1144             TOPOLOGIES_TAGS="2_node_*_link_topo"
1145             ;;
1146         "3n_snr")
1147             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_snr*.yaml )
1148             TOPOLOGIES_TAGS="3_node_single_link_topo"
1149             ;;
1150         "3n_tsh")
1151             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
1152             TOPOLOGIES_TAGS="3_node_single_link_topo"
1153             ;;
1154         "2n_tx2")
1155             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_tx2*.yaml )
1156             TOPOLOGIES_TAGS="2_node_single_link_topo"
1157             ;;
1158         "3n_alt")
1159             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_alt*.yaml )
1160             TOPOLOGIES_TAGS="3_node_single_link_topo"
1161             ;;
1162         "1n_aws")
1163             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*1n-aws*.yaml )
1164             TOPOLOGIES_TAGS="1_node_single_link_topo"
1165             ;;
1166         "2n_aws")
1167             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n-aws*.yaml )
1168             TOPOLOGIES_TAGS="2_node_single_link_topo"
1169             ;;
1170         "3n_aws")
1171             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n-aws*.yaml )
1172             TOPOLOGIES_TAGS="3_node_single_link_topo"
1173             ;;
1174         *)
1175             # No falling back to default, that should have been done
1176             # by the function which has set NODENESS and FLAVOR.
1177             die "Unknown specification: ${case_text}"
1178     esac
1179
1180     if [[ -z "${TOPOLOGIES-}" ]]; then
1181         die "No applicable topology found!"
1182     fi
1183 }
1184
1185
1186 function set_environment_variables () {
1187
1188     # Depending on testbed topology, overwrite defaults set in the
1189     # resources/libraries/python/Constants.py file
1190     #
1191     # Variables read:
1192     # - TEST_CODE - String affecting test selection, usually jenkins job name.
1193     # Variables set:
1194     # See specific cases
1195
1196     set -exuo pipefail
1197
1198     case "${TEST_CODE}" in
1199         *"1n-aws"* | *"2n-aws"* | *"3n-aws"*)
1200             # T-Rex 2.88+ workaround for ENA NICs.
1201             export TREX_RX_DESCRIPTORS_COUNT=1024
1202             export TREX_EXTRA_CMDLINE="--mbuf-factor 19"
1203             export TREX_CORE_COUNT=6
1204             # Settings to prevent duration stretching.
1205             export PERF_TRIAL_STL_DELAY=0.1
1206             ;;
1207         *"2n-zn2"*)
1208             # Maciek's workaround for Zen2 with lower amount of cores.
1209             export TREX_CORE_COUNT=14
1210     esac
1211 }
1212
1213
1214 function untrap_and_unreserve_testbed () {
1215
1216     # Use this as a trap function to ensure testbed does not remain reserved.
1217     # Perhaps call directly before script exit, to free testbed for other jobs.
1218     # This function is smart enough to avoid multiple unreservations (so safe).
1219     # Topo cleanup is executed (call it best practice), ignoring failures.
1220     #
1221     # Hardcoded values:
1222     # - default message to die with if testbed might remain reserved.
1223     # Arguments:
1224     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
1225     # Variables read (by inner function):
1226     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
1227     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
1228     # Variables set:
1229     # - TERRAFORM_MODULE_DIR - Terraform module directory.
1230     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
1231     # Trap unregistered:
1232     # - EXIT - Failure to untrap is reported, but ignored otherwise.
1233     # Functions called:
1234     # - die - Print to stderr and exit.
1235     # - ansible_playbook - Perform an action using ansible, see ansible.sh
1236
1237     set -xo pipefail
1238     set +eu  # We do not want to exit early in a "teardown" function.
1239     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
1240     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
1241     if [[ -z "${wt-}" ]]; then
1242         set -eu
1243         warn "Testbed looks unreserved already. Trap removal failed before?"
1244     else
1245         ansible_playbook "cleanup" || true
1246         python3 "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
1247             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
1248         }
1249         case "${TEST_CODE}" in
1250             *"1n-aws"* | *"2n-aws"* | *"3n-aws"*)
1251                 TERRAFORM_MODULE_DIR="terraform-aws-${NODENESS}-${FLAVOR}-c5n"
1252                 terraform_destroy || die "Failed to call terraform destroy."
1253                 ;;
1254             *)
1255                 ;;
1256         esac
1257         WORKING_TOPOLOGY=""
1258         set -eu
1259     fi
1260 }
1261
1262
1263 function warn () {
1264
1265     # Print the message to standard error.
1266     #
1267     # Arguments:
1268     # - ${@} - The text of the message.
1269
1270     set -exuo pipefail
1271
1272     echo "$@" >&2
1273 }